/*==========================================================================
*
*  Pexeso - edukacna hra
*  by Brandy
*  pouzite BonbliotFramework (c)
*
*  - Zobrazi karty, ktore treba korektne sparovat
*
*==========================================================================
*/

#include <ddraw.h>     //Direct Draw 
#include <mmsystem.h>  //koli LPWAVEFORMATEX v <dsound.h> a.i.
#include <dsound.h>    //Direct Sound

//----------------------
#include "DBonbliotFW.h"    //hlavicka hlavnej kniznice, FrameWork by Bonbliot (c)
//----------------------

#define IDC_BTN_MENU               100

#define IDC_DUIV_MAIN_DATA         101 
#define IDC_DUIV_MAIN_POCET        102 
#define IDC_DUIV_MAIN_ZAMIES       103 
#define IDC_DUIV_MAIN_OZVUC        104 
#define IDC_DUIV_MAIN_KONIEC       105 

#define IDC_DUIR_DATA              150 

#define IDC_DUIV_OBTIAZ_A          201
#define IDC_DUIV_OBTIAZ_B          202
#define IDC_DUIV_OBTIAZ_C          203
#define IDC_DUIV_OBTIAZ_D          204

#define IDC_DUIV_ZVUK_ZAP          301
#define IDC_DUIV_ZVUK_VYP          302


int mx;  //poloha mysi
int my;
bool pravedole = false;

//==================
bf_CDas_Surface  rezia;
bf_CDAS  kurzor;
bf_CDas_Surface  sprite_srf;
bf_CDAS *p_sprite_plane;   //i tak se da

bf_CDSO_Zvuk zvuk_1;
bf_CDSO_Zvuk zvuk_2;
bf_CDSO_Zvuk zvuk_3;
bf_CDSO_Zvuk zvuk_4;
//==================

//-----------------------------------------------
// App
//-----------------------------------------------
class CMyApp : public bf_CAppScreen
{
public:
  bf_CButton *btn_menu;           //tlacidlo na zapnutie menu

  bf_CDUI  *dui_Main;           //DUI instancia hlavneho menu
  bf_UTL_CDUIR_DIR  *utl_duir_DATA;   //submenu s podadresarmi dat
  bf_CDUI  *dui_Obtiaznost;     //submenu s obtiaznostou (pocet kariet)
  bf_CDUI  *dui_Zvuk;           //submenu zap/vyp zvuku

  bf_CLabel *label_debug_info;  //ladiaci vypis (zvolena akcia z menu)

  CMyApp(HINSTANCE hInstance, int nCmdShow, char* cLocApp_INI);
  ~CMyApp();
  virtual void Do_LOAD_SRF();
  virtual void Do_RELEASE_SRF();
  virtual void Do_RESTORE_SRF();
  virtual void Init();
  virtual int SetupVisual();
  //virtual void Init2();
  virtual void HandleWMInteraction(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam);
  virtual bool HandleFWInteraction(int iID, int ivalue, bf_CPos *p_pol = NULL);
  virtual void ChangedResolution(int maxx_old, int maxy_old, int maxx_new, int maxy_new);
  virtual void Redraw_Screen( LPDIRECTDRAWSURFACE p_lpDDS );
  virtual void DrawCursor( LPDIRECTDRAWSURFACE p_lpDDS );
};

//----------------------------------------------- 
// Konstruktor
//-----------------------------------------------
CMyApp::CMyApp(HINSTANCE hInstance, int nCmdShow, char* cLocApp_INI) : bf_CAppScreen(hInstance, nCmdShow, cLocApp_INI)
{
   p_sprite_plane = new bf_CDAS(this, 20,30);  //vytvorit a zaradit, zaevidovat k detom App-ky
                                               //(tym bude interaktivne na drag&drop a autovykreslovane) 
   btn_menu = new bf_CButton(this, IDC_BTN_MENU);
   dui_Main = new bf_CDUI(this, -1);
   utl_duir_DATA = new bf_UTL_CDUIR_DIR(this, IDC_DUIR_DATA );
   dui_Obtiaznost = new bf_CDUI(this, -1);
   dui_Zvuk = new bf_CDUI(this, -1);

   label_debug_info = new bf_CLabel(this, -1);
};

//-----------------------------------------------
// destruktor
//-----------------------------------------------
CMyApp::~CMyApp()
{
  zvuk_1.ODSTRAN();
  zvuk_2.ODSTRAN();
  zvuk_3.ODSTRAN();
  zvuk_4.ODSTRAN();
};

//-----------------------------------------------
// nahratie surfaces
//-----------------------------------------------
void CMyApp::Do_LOAD_SRF()
{
  rezia.LOAD_SURFACE((char*) "rezia.bmp");
  rezia.BC_SET(0, 0);
  rezia.TC_SET(3, 3);

  sprite_srf.LOAD_SURFACE((char*) "sprite_plane.bmp");
  sprite_srf.TC_SET(2, 2);
};

//----------------------------------------------------------------
// Uvolnit vsetky objekty surfaces
//----------------------------------------------------------------
void CMyApp::Do_RELEASE_SRF()
{
  rezia.RELEASE_SURFACE();
  sprite_srf.RELEASE_SURFACE();
}

//----------------------------------------------------------------
// Restore objektov surfaces
//----------------------------------------------------------------
void CMyApp::Do_RESTORE_SRF()
{
  rezia.RESTORE_SURFACE();
  sprite_srf.RESTORE_SURFACE();
}

//----------------------------------------------------------------
// Init inicializacie
//----------------------------------------------------------------
void CMyApp::Init()
{
  //zapiname log? 
  //bf_LOG_ON = true;
  //bf_LOG_ON = false;  //vypnut
  bf_LOG_SetONOFF( 1 );

  //zapiname zvuky?
  bf_DSO_ONOFF = true;
  //bf_DSO_ONOFF = false;  //vypnut

  kurzor.Das_Surface = &rezia;
  kurzor.REGISTER(5, 10);
  kurzor.REGISTER(25, 10);
  kurzor.x = 100;
  kurzor.y = 100;

  p_sprite_plane->Das_Surface = &sprite_srf;
  p_sprite_plane->REGISTER_CS();
  //p_sprite_plane->x = 20; p_sprite_plane->y = 30;

  //<-- hlavne menu dui_Main ----------------
  dui_Main->ADD(IDC_DUIV_MAIN_DATA,   (char*) "DTA - karty...");
  dui_Main->ADD(IDC_DUIV_MAIN_POCET,  (char*) "Poet kariet...");
  dui_Main->ADD(IDC_DUIV_MAIN_ZAMIES, (char*) "Zamieaj");
  dui_Main->ADD(IDC_DUIV_MAIN_OZVUC,  (char*) "Ozvuenie kariet...");
  dui_Main->ADD(IDC_DUIV_MAIN_KONIEC, (char*) "Koniec");
  dui_Main->visible = false;

  //<-- nacitat podadresare s datami ------------------ 
  utl_duir_DATA->DELETE_ALL();
  //utl_duir_DATA->LOAD((char*) "..\\", (char*) "DATA*");
  utl_duir_DATA->LOAD( (char*) "DATA*", 5);
  utl_duir_DATA->visible = false;

  //<-- pocet kariet - obtiaznost
  dui_Obtiaznost->DELETE_ALL();
  dui_Obtiaznost->ADD(IDC_DUIV_OBTIAZ_A, (char*) "[4x4] - ahk A");
  dui_Obtiaznost->ADD(IDC_DUIV_OBTIAZ_B, (char*) "[5x4] - ahk B");
  dui_Obtiaznost->ADD(IDC_DUIV_OBTIAZ_C, (char*) "[6x4] - stredn");
  dui_Obtiaznost->ADD(IDC_DUIV_OBTIAZ_D, (char*) "[8x5] - ak");
  dui_Obtiaznost->visible = false;

  //<-- zmena ozvucenia
  dui_Zvuk->DELETE_ALL();
  dui_Zvuk->ADD(IDC_DUIV_ZVUK_VYP, (char*) "Vypn");
  dui_Zvuk->ADD(IDC_DUIV_ZVUK_ZAP, (char*) "Zapn");
  dui_Zvuk->visible = false;

  //autopopup - mechanizmus samorozbalenia submenu z hlavneho menu
  dui_Main->Join_Master_Detail_popup(IDC_DUIV_MAIN_DATA,  utl_duir_DATA);
  dui_Main->Join_Master_Detail_popup(IDC_DUIV_MAIN_POCET, dui_Obtiaznost);
  dui_Main->Join_Master_Detail_popup(IDC_DUIV_MAIN_OZVUC, dui_Zvuk);

  zvuk_1.NAHRAJ((char*) "zvuknaraz.wav");
  zvuk_2.NAHRAJ((char*) "zvukkoniec.wav");
  zvuk_3.NAHRAJ((char*) "zvuktada.wav");
  zvuk_4.NAHRAJ((char*) "zvukcvak.wav");
}

//-----------------------------------------------
// Nastavi vizual, dizajn
//-----------------------------------------------
int CMyApp::SetupVisual()
{
  bf_CAppScreen::SetupVisual(); //obsluzit najprv predka (od koho je App odvodena)

  btn_menu->Dsgn2_UserA(m_SX - 70, 0, &rezia, 80, 10, 80, 40, 80, 40);

  dui_Main->RESET_DEFAULT();
  dui_Main->autohide = true;

  label_debug_info->CR_text_color = RGB(255,255,255);
  label_debug_info->font_hnd =
    CreateFont(
      30,                        // { height }
      13,                        // { width }
      0,                         // { escapement }
      0,                         // { orientation }
      FW_NORMAL,                 // { weight }
      0,                         // { italic }
      0,                         // { underline }
      0,                         // { strikeOut }
      EASTEUROPE_CHARSET,  //ANSI_CHARSET,              // { char set }
      OUT_DEFAULT_PRECIS,        // { OutputPrecision }
      CLIP_DEFAULT_PRECIS,       // { ClipPrecision }
      DEFAULT_QUALITY,           // { quality }
      VARIABLE_PITCH | FF_SWISS, // { PitchAndFamily }
      "Verdana"  //"Arial" 
    );
  label_debug_info->SetText((LPSTR) "[Menu?]");
  label_debug_info->GO_TO_REL_CENTER(m_SX, m_SY);

  return 0;
}

//----------------------------------------------------------------
// Spracovanie WM 
//----------------------------------------------------------------
void CMyApp::HandleWMInteraction(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{

  switch (message)
  {

  case WM_CREATE:
    break;

  case WM_KEYDOWN:

    switch (wParam)
    {

    case VK_SPACE:
      dui_Main->visible = true;
      dui_Main->trieda++;
      if (dui_Main->trieda>2) dui_Main->trieda = 0;   //0
             //-------------
      dui_Main->RESET_DEFAULT();
             //-------------
      dui_Main->autohide = false;
      //zvuk_3.SPUSTI(); //<<<<<<DEBUG 
      break;

    case VK_ESCAPE:       //koniec aplikacie
    case VK_F12:
      zvuk_2.SPUSTI();  //koniec
      //Close();
      break;
    }

    break;

  case WM_LBUTTONDOWN:      //lavy klik mysou
    kurzor.SF(1);
    break;

  case WM_LBUTTONUP:        //lavy unklik mysou (UP) 
    kurzor.SF(0);
    break;

  case WM_RBUTTONDOWN:      //pravy klik mysou
    mx = LOWORD(lParam);
    my = HIWORD(lParam);

    dui_Main->visible = true;
    dui_Main->GO_TO_CENTER(mx, my);

    zvuk_1.SPUSTI();
    pravedole = true;
    break;

  case WM_RBUTTONUP:        //pravy unklik mysou
    pravedole = false;
    break;

  case WM_MOUSEMOVE:        //pohyb mysou
    mx = LOWORD(lParam);
    my = HIWORD(lParam);
    kurzor.x = mx;
    kurzor.y = my;

    if (pravedole)
      dui_Main->GO_TO_CENTER(mx, my);

    break;

  case WM_TIMER:            //periodicke aktivity na timer
    if (wParam == 1) //BTFW main timer
    {
      if (p_sprite_plane->state != 2) p_sprite_plane->x += 2;
      if (p_sprite_plane->x > m_MAXX + 200) p_sprite_plane->x = -600;
    }
    break;
  }
}


//----------------------------------------------------------------
// Da priestor na akciu - spracovanie FWM
//----------------------------------------------------------------
bool CMyApp::HandleFWInteraction(int iID, int ivalue, bf_CPos *p_pol)
{
  //postup cez dimenziu predkov
  bool l_b = bf_CAppScreen::HandleFWInteraction(iID, ivalue, p_pol);  //bud tu obsluzit class predka

  bool volba = false;

  switch (iID)
  {

  case IDC_BTN_MENU:    //hlavne menu tlacidlo
    if (!dui_Main->visible)  dui_Main->visible = true;
    dui_Main->GO_TO(m_SX - 64, 28);
    zvuk_1.SPUSTI();
    break;

  case IDC_DUIR_DATA:    //Data vyber
    bf_TCHOICER * v = utl_duir_DATA->VratVolbu__hodnotovo( ivalue );
    if (v == NULL)
    {
      label_debug_info->SetText((LPSTR) "Nenjden voba");
      //bf_ERROR("Nenajdena volba");
      //assert(0);
    }
    else if (v->data != NULL)
    {   //precitame zavesenu cestu k adresaru  "..\\DATA*\\"
      label_debug_info->SetText((LPSTR)(v->data));
      //bf_LOGT("Nacitavam DATA:", (char*)(v->data));  //<<<<<< DEBUG
      volba = true;
    }
    break;
  }

  if (! volba)
  switch (ivalue)
  {
  case IDC_DUIV_MAIN_ZAMIES:
    label_debug_info->SetText((LPSTR) "Zamiea");
    volba = true;
    break;
  case IDC_DUIV_MAIN_KONIEC:
    label_debug_info->SetText((LPSTR) "Koniec");
    volba = true;
    break;

  case IDC_DUIV_OBTIAZ_A:
    label_debug_info->SetText((LPSTR) "Obtianos A");
    volba = true;
    break;
  case IDC_DUIV_OBTIAZ_B:
    label_debug_info->SetText((LPSTR) "Obtianos B");
    volba = true;
    break;
  case IDC_DUIV_OBTIAZ_C:
    label_debug_info->SetText((LPSTR) "Obtianos C");
    volba = true;
    break;
  case IDC_DUIV_OBTIAZ_D:
    label_debug_info->SetText((LPSTR) "Obtianos D");
    volba = true;
    break;

  case IDC_DUIV_ZVUK_ZAP:
    label_debug_info->SetText((LPSTR) "Zvuk zapn");
    volba = true;
    break;
  case IDC_DUIV_ZVUK_VYP:
    label_debug_info->SetText((LPSTR) "Zvuk vypn");
    volba = true;
    break;
  }

  if (volba )
  {
    label_debug_info->GO_TO_REL_CENTER(m_SX, m_SY);
    zvuk_4.SPUSTI();  //cvak
  }

  return l_b;
}

//----------------------------------------------------------------
// Volane po zmene rozmerov obrazovky
//----------------------------------------------------------------
void CMyApp::ChangedResolution(int maxx_old, int maxy_old, int maxx_new, int maxy_new)
{
  //postup cez dimenziu predkov (vratit funkcnost predkovi, lebo cez virtual bola obidena, prepisana)
  bf_CAppScreen::ChangedResolution(maxx_old, maxy_old, maxx_new, maxy_new);  //obsluzit class predka

  btn_menu->MoveToRel(m_SX - 70, 0);
  label_debug_info->GO_TO_REL_CENTER(m_SX, m_SY);
}

//----------------------------------------------------------------
// Prekreslit celu scenu 
//----------------------------------------------------------------
void CMyApp::Redraw_Screen( LPDIRECTDRAWSURFACE p_lpDDS )
{
  //<--- vymazat
  //DDSURFACE_ZMAZ(p_lpDDS, 500);

}

//----------------------------------------------------------------
// Vykreslit kurzor
//----------------------------------------------------------------
void CMyApp::DrawCursor( LPDIRECTDRAWSURFACE p_lpDDS )
{
  //<--- poloz kuzor
  kurzor.DRAW(p_lpDDS);
}

//==============================================================================

//----------------------------------------------------------------
// Vstupny bod pre Appku
//----------------------------------------------------------------
int PASCAL WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance,
  LPSTR lpCmdLine, int nCmdShow)
{
  CMyApp *pAPP = new CMyApp(hInstance, nCmdShow, (char*) "PEXESO.INI");
  pAPP->SetBackground(500, (char*)"", false );   //modra farba pozadia, ziaden obraz ako podklad, ziadne logo
  pAPP->SetAppInfo((char*)"Pexeso", (char*)"(verzia: 1.0)", (char*)"Branislav Lehotsk", &rezia, 20, 40);
  pAPP->SetSysCursor( false );
  pAPP->SetLang(bf_c_Lang_SK);
  pAPP->Execute();
  delete pAPP;
  return 0;
}
