/*==========================================================================
*
*  Pexeso - edukacna hra
*  by Brandy
*  pouzite BonbliotFramework (c)
*
*  - Zobrazi karty, ktore treba korektne sparovat
*
*==========================================================================
*/

#include <ddraw.h>     //Direct Draw 
#include <mmsystem.h>  //koli LPWAVEFORMATEX v <dsound.h> a.i.
#include <dsound.h>    //Direct Sound
#include <time.h>      //koli srand,time

//----------------------
#include "DBonbliotFW.h"    //hlavicka hlavnej kniznice, FrameWork by Bonbliot (c)
//----------------------

#define IDC_BTN_MENU               100

#define IDC_DUIV_MAIN_DATA         101 
#define IDC_DUIV_MAIN_POCET        102 
#define IDC_DUIV_MAIN_ZAMIES       103 
#define IDC_DUIV_MAIN_OZVUC        104 
#define IDC_DUIV_MAIN_KONIEC       105 

#define IDC_DUIR_DATA              150 

#define IDC_DUIV_OBTIAZ_A          201
#define IDC_DUIV_OBTIAZ_B          202
#define IDC_DUIV_OBTIAZ_C          203
#define IDC_DUIV_OBTIAZ_D          204

#define IDC_DUIV_ZVUK_ZAP          301
#define IDC_DUIV_ZVUK_VYP          302


int mx;  //poloha mysi
int my;
bool pravedole = false;

//==================
bf_CDas_Surface  rezia;
bf_CDAS  kurzor;
bf_CDas_Surface  sprite_srf;
bf_CDAS *p_sprite_plane;   //i tak se da

bf_CDSO_Zvuk zvuk_1;
bf_CDSO_Zvuk zvuk_2;
bf_CDSO_Zvuk zvuk_3;
bf_CDSO_Zvuk zvuk_4;

bf_CDUIR duir_FINAL( (char*)"duir_FINAL" ); //DUIR pre uz pospajane pary

bf_CARRE  REG_KARTY;      //register kariet
bf_CARRE  REG_OBR;        //register obrazov
bf_CARRE  REG_TEXT;       //register text
bf_CARRE  REG_ZVUK;       //register zvukov

bf_CARRE arre_DATA_adresare;  //mena adresarov s DATAmi

bf_CIcon *p_icon_back_side;

//==================

int i_chyteny = -1;
int i_dotknuty = -1;
int i_posl_dotkn = -1;

HPEN   pero_ramec_1;
HPEN   pero_ramec_2;

int SIR_KARTA = 150;
int VYS_KARTA = 100;  //po spodok obrazka
int VYS_KARTA2 = 150;

//font, ktorym budu default texty (nastavenie v Init)
HFONT glob_font_KARTY_HND = NULL;
int glob_font_KARTY_SIR;
int glob_font_KARTY_VYS;
TCHAR *glob_font_KARTY_FaceName;

bool ozvuc_zap = true;
int hra_stav;
int hra_cas;
class CKarta;
CKarta *karta1;  //otvorene karty (do REG_KARTY[i])
CKarta *karta2;

int M = 6;    //stlpcov
int N = 4;    //riadkov
int O = 200;  //odsadenie pre DUIR
int D = 40;   //medzery

const int MAXX_D_Mantinel = 1600;

//------------------------------------------------------
HFONT My_Font_Create(int font_vys, int font_sir, LPCTSTR font_face);
void font_SET2();
void Uprav_M_N();
void NACITAJ(char *folderpath /*, bool default_transpar =true*/);
void PridajKartu(int xx, int yy, int iindex);
void VYBER_KARTY_DVOJICE(int ppocet_dvojic);
void ULOZ_KARTY();
void ZAMIESAJ_KARTY();
void ZOBRAZ_KARTY(LPDIRECTDRAWSURFACE d_SRF);
void REG_UVOLNI();
//------------------------------------------------------

//------------------------------------------------------
// DD Dialog EFEKT 
//------------------------------------------------------
class CKarta : public bf_CDialog_EFFECT
{
public:
  bool otvorena;
  int index;
};

/*
CKarta::CKarta( int xx, int yy, int ssir, int vvys )
::bf_CDialog_EFFECT( xx, yy, ssir, vvys, "?")
{
pruh_h = 0;   //bez pruhu
pruh_senzitivnost = false; //uchopitelny celou obalkou!
}
*/

//------------------------------------------------------
// element, polozka s textom
//------------------------------------------------------
struct SText
{
  LPSTR text;
  HFONT font_local;
  SText();
};

SText::SText()
{
  text = NULL;
  font_local = NULL;
};

//-----------------------------------------------
// App
//-----------------------------------------------
class CMyApp : public bf_CAppScreen
{
public:
  bf_CButton *btn_menu;           //tlacidlo na zapnutie menu

  bf_CDUI  *dui_Main;           //DUI instancia hlavneho menu
  bf_UTL_CDUIR_DIR  *utl_duir_DATA;   //submenu s podadresarmi dat
  bf_CDUI  *dui_Obtiaznost;     //submenu s obtiaznostou (pocet kariet)
  bf_CDUI  *dui_Zvuk;           //submenu zap/vyp zvuku

  //bf_CLabel *label_debug_info; //ladiaci vypis (zvolena akcia z menu)
  bf_CLabel * lb_Gratul;         //gratulacia na zaver

  CMyApp(HINSTANCE hInstance, int nCmdShow, char* cLocApp_INI);
  ~CMyApp();
  virtual void Do_LOAD_SRF();
  virtual void Do_RELEASE_SRF();
  virtual void Do_RESTORE_SRF();
  virtual void Init();
  virtual int SetupVisual();
  //virtual void Init2();
  virtual void HandleWMInteraction(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam);
  virtual bool HandleFWInteraction(int iID, int ivalue, bf_CPos *p_pol = NULL);
  virtual void ChangedResolution(int maxx_old, int maxy_old, int maxx_new, int maxy_new);
  virtual void Redraw_Screen( LPDIRECTDRAWSURFACE p_lpDDS );
  virtual void DrawCursor( LPDIRECTDRAWSURFACE p_lpDDS );
};

//----------------------------------------------- 
// Konstruktor
//-----------------------------------------------
CMyApp::CMyApp(HINSTANCE hInstance, int nCmdShow, char* cLocApp_INI) : bf_CAppScreen(hInstance, nCmdShow, cLocApp_INI)
{
   p_sprite_plane = new bf_CDAS(this, 20,30);  //vytvorit a zaradit, zaevidovat k detom App-ky
                                               //(tym bude interaktivne na drag&drop a autovykreslovane) 
   btn_menu = new bf_CButton(this, IDC_BTN_MENU);
   dui_Main = new bf_CDUI(this, -1);
   utl_duir_DATA = new bf_UTL_CDUIR_DIR(this, IDC_DUIR_DATA );
   dui_Obtiaznost = new bf_CDUI(this, -1);
   dui_Zvuk = new bf_CDUI(this, -1);

   //label_debug_info = new bf_CLabel(this, -1);
   lb_Gratul = new bf_CLabel(this, -1);
};

//-----------------------------------------------
// destruktor
//-----------------------------------------------
CMyApp::~CMyApp()
{
  delete p_sprite_plane;
  delete btn_menu;
  delete dui_Main;
  delete utl_duir_DATA;
  delete dui_Obtiaznost;
  delete dui_Zvuk;
  delete lb_Gratul;

  zvuk_1.ODSTRAN();
  zvuk_2.ODSTRAN();
  zvuk_3.ODSTRAN();
  zvuk_4.ODSTRAN();

  DeleteObject(pero_ramec_1);
  DeleteObject(pero_ramec_2);

  KillTimer( bf_Get_APP_hWnd_GLOB(), 2);

  REG_UVOLNI();  //uvolnit datove struktury
};

//-----------------------------------------------
// nahratie surfaces
//-----------------------------------------------
void CMyApp::Do_LOAD_SRF()
{
  rezia.LOAD_SURFACE((char*) "rezia.bmp");
  rezia.BC_SET(0, 0);
  rezia.TC_SET(3, 3);

  sprite_srf.LOAD_SURFACE((char*) "sprite_plane.bmp");
  sprite_srf.TC_SET(2, 2);
};

//----------------------------------------------------------------
// Uvolnit vsetky objekty surfaces
//----------------------------------------------------------------
void CMyApp::Do_RELEASE_SRF()
{
  rezia.RELEASE_SURFACE();
  sprite_srf.RELEASE_SURFACE();
}

//----------------------------------------------------------------
// Restore objektov surfaces
//----------------------------------------------------------------
void CMyApp::Do_RESTORE_SRF()
{
  rezia.RESTORE_SURFACE();
  sprite_srf.RESTORE_SURFACE();
}

//----------------------------------------------------------------
// Init inicializacie
//----------------------------------------------------------------
void CMyApp::Init()
{
  //zapiname log? 
  //bf_LOG_ON = true;
  //bf_LOG_ON = false;  //vypnut
  bf_LOG_SetONOFF( 1 );

  //zapiname zvuky?
  bf_DSO_ONOFF = true;
  //bf_DSO_ONOFF = false;  //vypnut

  kurzor.Das_Surface = &rezia;
  kurzor.REGISTER(5, 10);
  kurzor.REGISTER(25, 10);
  kurzor.x = 100;
  kurzor.y = 100;

  p_sprite_plane->Das_Surface = &sprite_srf;
  p_sprite_plane->REGISTER_CS();
  //p_sprite_plane->x = 20; p_sprite_plane->y = 30;

  //<-- hlavne menu dui_Main ----------------
  dui_Main->ADD(IDC_DUIV_MAIN_DATA,   (char*) "DTA - karty...");
  dui_Main->ADD(IDC_DUIV_MAIN_POCET,  (char*) "Poet kariet...");
  dui_Main->ADD(IDC_DUIV_MAIN_ZAMIES, (char*) "Zamieaj");
  dui_Main->ADD(IDC_DUIV_MAIN_OZVUC,  (char*) "Ozvuenie kariet...");
  dui_Main->ADD(IDC_DUIV_MAIN_KONIEC, (char*) "Koniec");
  dui_Main->visible = false;

  //<-- nacitat podadresare s datami ------------------ 
  utl_duir_DATA->DELETE_ALL();
  //utl_duir_DATA->LOAD((char*) "..\\", (char*) "DATA*");
  utl_duir_DATA->LOAD((char*) "DATA*", 5);
  utl_duir_DATA->visible = false;

  //<-- pocet kariet - obtiaznost
  dui_Obtiaznost->DELETE_ALL();
  dui_Obtiaznost->ADD(IDC_DUIV_OBTIAZ_A, (char*) "[4x4] - ahk A");
  dui_Obtiaznost->ADD(IDC_DUIV_OBTIAZ_B, (char*) "[5x4] - ahk B");
  dui_Obtiaznost->ADD(IDC_DUIV_OBTIAZ_C, (char*) "[6x4] - stredn");
  dui_Obtiaznost->ADD(IDC_DUIV_OBTIAZ_D, (char*) "[8x5] - ak");
  dui_Obtiaznost->visible = false;

  //<-- zmena ozvucenia
  dui_Zvuk->DELETE_ALL();
  dui_Zvuk->ADD(IDC_DUIV_ZVUK_VYP, (char*) "Vypn");
  dui_Zvuk->ADD(IDC_DUIV_ZVUK_ZAP, (char*) "Zapn");
  dui_Zvuk->visible = false;

  //autopopup - mechanizmus samorozbalenia submenu z hlavneho menu
  dui_Main->Join_Master_Detail_popup(IDC_DUIV_MAIN_DATA,  utl_duir_DATA);
  dui_Main->Join_Master_Detail_popup(IDC_DUIV_MAIN_POCET, dui_Obtiaznost);
  dui_Main->Join_Master_Detail_popup(IDC_DUIV_MAIN_OZVUC, dui_Zvuk);

  zvuk_1.NAHRAJ((char*) "zvuknaraz.wav");
  zvuk_2.NAHRAJ((char*) "zvukkoniec.wav");
  zvuk_3.NAHRAJ((char*) "zvuktada.wav");
  zvuk_4.NAHRAJ((char*) "zvukcvak.wav");

  //<-- vysledny artefakt
  duir_FINAL.RESET_DEFAULT();
  duir_FINAL.GO_TO(1, 1);
  duir_FINAL.visible = true;
  duir_FINAL.autohide = false;   //neskryvat
  int delta = 18; //20;
  duir_FINAL.a = VYS_KARTA + delta; duir_FINAL.b = VYS_KARTA + delta + 8; duir_FINAL.c = SIR_KARTA; duir_FINAL.d = 10;
  duir_FINAL.SetIconMode((char*) "LT" /*"CT"*/);  //Center-Top
  duir_FINAL.IconPadding = 1;
  duir_FINAL.SetTextMode((char*) "CB");  //Center-Bottom
  duir_FINAL.TextPadding = 1;
  duir_FINAL.Rol_poc_zobr = 6;
  duir_FINAL.DELETE_ALL();     //nechcem ani ziadne default blendovacie
  duir_FINAL.Border = 1;
  duir_FINAL.Keep_Last = true;  //chceme byt vzdy scrolnuty naspodku

  //pera na ramceky (dotknuta, chytena karta) 
  pero_ramec_1 = CreatePen(PS_SOLID, 3, RGB(0, 255, 0));
  pero_ramec_2 = CreatePen(PS_SOLID, 3, RGB(255, 0, 0));

  //--------------- //NOTE: po  DSO_INIT, lebo tam vytvarame aj zvuky
  //prvu sadu kariet:
  bf_TCHOICER *v = utl_duir_DATA->VratVolbu__indexovo( /*0*/ utl_duir_DATA->Count() - 1);
  if (v == NULL)
  {
    bf_ERROR("Nenajdena volba");
    assert(0);
  }
  //precitame zavesenu cestu k adresaru  "..\\DATA*\\"
  if (v->data != NULL)
  {
    bf_LOGT("Nacitavam DATA:", (char*)(v->data));  //<<<<<< DEBUG

    Uprav_M_N(); //korekcia

  //-------
    NACITAJ((char*)(v->data));
  //-------
    ZAMIESAJ_KARTY();
    ULOZ_KARTY();
  }
  lb_Gratul->visible = false;
  //---------------

  //font, ktorym budu default texty
  glob_font_KARTY_SIR = 18;
  glob_font_KARTY_VYS = 22;
  glob_font_KARTY_FaceName = new TCHAR[30];
  strcpy( glob_font_KARTY_FaceName,  (TCHAR *) "Verdana");
  //bf_LOGT("glob_font_KARTY_FaceName:", (char*)glob_font_KARTY_FaceName);  //<<<<<< DEBUG
  //--------------  
  glob_font_KARTY_HND = My_Font_Create( glob_font_KARTY_VYS, glob_font_KARTY_SIR, glob_font_KARTY_FaceName /*"Verdana"*/ );
  //--------------  
  font_SET2();

  //---
  p_icon_back_side = new bf_CIcon((char*) "card_back_side.bmp");
  hra_stav = 0;
  hra_cas = 0;
  karta1 = karta2 = NULL;

  //timer na vyhodnotenie tahu a efekty
  SetTimer( bf_Get_APP_hWnd_GLOB(), 2, 330, NULL);
}

//-----------------------------------------------
// Nastavi vizual, dizajn
//-----------------------------------------------
int CMyApp::SetupVisual()
{
  bf_CAppScreen::SetupVisual(); //obsluzit najprv predka (od koho je App odvodena)

  btn_menu->Dsgn2_UserA(m_SX - 70, 0, &rezia, 80, 10, 80, 40, 80, 40);

  dui_Main->RESET_DEFAULT();
  dui_Main->autohide = true;

  lb_Gratul->Dsgn(50, m_SY - 75, (char*) "Super! Gratulujeme!");
  lb_Gratul->CR_text_color = RGB(255, 255, 255);
  lb_Gratul->visible = false;
  lb_Gratul->font_hnd =
    CreateFont(150,                       // { height }
      65,                        // { width }
      0,                         // { escapement }
      0,                         // { orientation }
      FW_NORMAL,                 // { weight }
      0,                         // { italic }
      0,                         // { underline }
      0,                         // { strikeOut }
      EASTEUROPE_CHARSET,  //ANSI_CHARSET,              // { char set }
      OUT_DEFAULT_PRECIS,        // { OutputPrecision }
      CLIP_DEFAULT_PRECIS,       // { ClipPrecision }
      DEFAULT_QUALITY,           // { quality }
      VARIABLE_PITCH | FF_SWISS, // { PitchAndFamily }
      "Verdana"  //"Arial" 
    );

  return 0;
}

//----------------------------------------------------------------
// Spracovanie WM 
//----------------------------------------------------------------
void CMyApp::HandleWMInteraction(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
  CKarta *pde;
  CKarta *pK;
  bf_CDSO_Zvuk *pz;
  int i; //,j;

  switch (message)
  {

  case WM_CREATE:
    break;

  case WM_KEYDOWN:

    switch (wParam)
    {

    case VK_SPACE:
      dui_Main->visible = true;
      dui_Main->trieda++;
      if (dui_Main->trieda>2) dui_Main->trieda = 0;   //0
             //-------------
      dui_Main->RESET_DEFAULT();
             //-------------
      dui_Main->autohide = false;
      //zvuk_3.SPUSTI(); //<<<<<<DEBUG 
      break;

    case VK_ESCAPE:       //koniec aplikacie
    case VK_F12:
      zvuk_2.SPUSTI();  //koniec
      //Close();
      break;
    }

    break;

  case WM_LBUTTONDOWN:      //lavy klik mysou
    kurzor.SF(1);

    int hod;
    duir_FINAL.INFORM_SELF(mx, my, 1);
    if (duir_FINAL.INFORM_ME(&hod))
    {
      //chceme aj prehrat prislusny zvuk
      pz = (bf_CDSO_Zvuk *)REG_ZVUK[hod];
      if (pz != NULL) pz->SPUSTI();
    };

    //ked dialogy => nekomunikovat karty
    if (m_dlg_AppRozlis->visible || m_dlg_AppTimer->visible || m_dlg_AppInfo->visible || dui_Main->visible)
      break;

    //----------- nechceme cakat na timer2 kym to zavrie, pokracujeme svizne v hre 
    if (hra_stav >= 2)
    {
      if (karta1->index != karta2->index) //netrefa
      {
        karta1->otvorena = false;
        karta2->otvorena = false;
        hra_cas = 0;
        hra_stav = 0;
      }
    }
    //-----------

    //----------- otvaranie kariet 1,2
    if (i_dotknuty >= 0)
    {
      i_chyteny = i_dotknuty;
      i_dotknuty = -1;
      pde = (CKarta *)REG_KARTY[i_chyteny];
      pde->INFORM_SELF(mx, my, 1);

      //pde->otvorena = ! pde->otvorena; //otvorit/zavriet
      if (!pde->otvorena && hra_stav < 2)
      {
        pde->otvorena = true;

        //aj prehrat prislusny zvuk
        if (ozvuc_zap)
        {
          pz = (bf_CDSO_Zvuk *)REG_ZVUK[pde->index];
          if (pz != NULL) pz->SPUSTI();
        }

        hra_stav++;
        if (hra_stav == 1) karta1 = pde;
        if (hra_stav == 2) karta2 = pde;
      }
    }
    //-----------
    break;

  case WM_LBUTTONUP:        //lavy unklik mysou (UP) 
    kurzor.SF(0);

    duir_FINAL.INFORM_SELF(mx, my, -1);

    //ked dialogy => nekomunikovat karty
    if (m_dlg_AppRozlis->visible || m_dlg_AppTimer->visible || m_dlg_AppInfo->visible || dui_Main->visible)
      break;

    //-----------  spracovanie "pustenia" karty
    if (i_dotknuty >= 0)   //zeleny
    {
      pK = (CKarta *)REG_KARTY[i_dotknuty];
      pK->INFORM_SELF(mx, my, -1);
      i_dotknuty = -1;
    };
    if (i_chyteny >= 0)    //cerveny
    {
      pK = (CKarta *)REG_KARTY[i_chyteny];
      pK->INFORM_SELF(mx, my, -1);
      i_chyteny = -1;
    };
    //-----------
    break;

  case WM_RBUTTONDOWN:      //pravy klik mysou
    mx = LOWORD(lParam);
    my = HIWORD(lParam);

    dui_Main->visible = true;
    dui_Main->GO_TO_CENTER(mx, my);

    zvuk_1.SPUSTI();
    pravedole = true;
    break;

  case WM_RBUTTONUP:        //pravy unklik mysou
    pravedole = false;
    break;

  case WM_MOUSEMOVE:        //pohyb mysou
    mx = LOWORD(lParam);
    my = HIWORD(lParam);
    kurzor.x = mx;
    kurzor.y = my;

    duir_FINAL.INFORM_SELF(mx, my, 0);

    //ked dialogy => nekomunikovat karty
    if (m_dlg_AppRozlis->visible || m_dlg_AppTimer->visible || m_dlg_AppInfo->visible || dui_Main->visible)
      break;

    //-----------
    if (i_chyteny >= 0)
    {
      pde = (CKarta *)REG_KARTY[i_chyteny];  //vzdy, aj prudkym dragom premiestnit
      pde->INFORM_SELF(mx, my, 0);
    }
    else
    {
      //najst prvy ostro zasiahnuty od konca (ak nenajde, tak ostane posledne dotknuty)
      i_dotknuty = -1;
      for (i = REG_KARTY.count - 1; i >= 0; i--)  //spatne
      {
        pde = (CKarta *)REG_KARTY[i];
        if (pde->visible)
          if (bf_glob_test_in_rect(pde->x, pde->y, pde->x + pde->sir, pde->y + pde->vys, mx, my))    //mys v obalke ?
          {
            i_dotknuty = i;
            i_posl_dotkn = i;
            break;
          }
      }
      if (i_dotknuty >= 0)
      {
        pde = (CKarta *)REG_KARTY[i_dotknuty];
        pde->INFORM_SELF(mx, my, 0);
      }
    }
    //-----------

    if (pravedole)
      dui_Main->GO_TO_CENTER(mx, my);

    break;

  case WM_TIMER:            //periodicke aktivity na timer
    if (wParam == 1) //BTFW main timer
    {
      if (p_sprite_plane->state != 2) p_sprite_plane->x += 2;
      if (p_sprite_plane->x > m_MAXX + 200) p_sprite_plane->x = -600;
    }
    if (wParam == 2) //APP timer
    {
      //zvuk_1.SPUSTI();   //<<<<<< DEBUG  pulz

      //---
      if (hra_stav >= 2)
      {
        hra_cas++;

        if (karta1->index == karta2->index) //trefa?
        {
          if (hra_cas == 3 || hra_cas == 5 || hra_cas == 7)  //blikacka
            karta1->visible = karta2->visible = false;
          else
            karta1->visible = karta2->visible = true;
        }

        if (hra_cas >= 9 /*12*/ /*5*/)
        {
          if (karta1->index == karta2->index) //trefa?
          {
            zvuk_1.SPUSTI();

            karta1->visible = false;   //skryt obe karty
            karta2->visible = false;

            //aj zavesit na FINAL nastenku
            bf_CIcon *p_icon = (bf_CIcon *)REG_OBR[karta1->index];
            SText *p_txt = (SText *)REG_TEXT[karta1->index];
            duir_FINAL.ADD(karta1->index, p_txt->text, p_icon, false);  //apropo mame Keep_Last, teda autoscroluje sa naspodok

                                                                           //test na finale
            if (duir_FINAL.VOLR.count == (REG_KARTY.count / 2))  //vsetko uhadnute?
            {
              lb_Gratul->visible = true;
              zvuk_3.SPUSTI();  //tada
            }
          }
          else  //rozne
          {
            karta1->otvorena = false;
            karta2->otvorena = false;
          }
          hra_cas = 0;
          hra_stav = 0;
        }
      } //if hra_stav == 2
    }
    break;
  }
}


//----------------------------------------------------------------
// Da priestor na akciu - spracovanie FWM
//----------------------------------------------------------------
bool CMyApp::HandleFWInteraction(int iID, int ivalue, bf_CPos *p_pol)
{
  //postup cez dimenziu predkov
  bool l_b = bf_CAppScreen::HandleFWInteraction(iID, ivalue, p_pol);  //bud tu obsluzit class predka

  bool volba = false;

  switch (iID)
  {

  case IDC_BTN_MENU:    //hlavne menu tlacidlo
    if (!dui_Main->visible)  dui_Main->visible = true;
    dui_Main->GO_TO(m_SX - 64, 28);
    zvuk_1.SPUSTI();
    break;

  case IDC_DUIR_DATA:    //Data vyber
    bf_TCHOICER * v = utl_duir_DATA->VratVolbu__hodnotovo( ivalue );
    if (v == NULL)
    {
      //label_debug_info->SetText((LPSTR) "Nenjden voba");
      bf_ERROR("Nenajdena volba");
      assert(0);
    }
    else if (v->data != NULL)
    {   //precitame zavesenu cestu k adresaru  "..\\DATA*\\"
      //label_debug_info->SetText((LPSTR)(v->data));
      bf_LOGT("Nacitavam DATA:", (char*)(v->data));  //<<<<<< DEBUG
      volba = true;

      NACITAJ((char*)(v->data));
      //-------
      ZAMIESAJ_KARTY();
      ULOZ_KARTY();
      font_SET2();  //aby font textov 'sadol' do kariet
    }
    break;
  }

  if (! volba)
  {
    switch (ivalue)
    {
    case IDC_DUIV_MAIN_ZAMIES:
      //label_debug_info->SetText((LPSTR) "Zamiea");
      ZAMIESAJ_KARTY();
      volba = true;
      break;
    case IDC_DUIV_MAIN_KONIEC:
      //label_debug_info->SetText((LPSTR) "Koniec");
      zvuk_2.SPUSTI();  //koniec
      Close();
      //volba = true;
      break;

    case IDC_DUIV_OBTIAZ_A:
      //label_debug_info->SetText((LPSTR) "Obtianos A");
      M = 4; N = 4;
      D = 40;
      volba = true;
      break;
    case IDC_DUIV_OBTIAZ_B:
      //label_debug_info->SetText((LPSTR) "Obtianos B");
      M = 5; N = 4;
      D = 40;
      volba = true;
      break;
    case IDC_DUIV_OBTIAZ_C:
      //label_debug_info->SetText((LPSTR) "Obtianos C");
      M = 6; N = 4;
      D = 40;
      volba = true;
      break;
    case IDC_DUIV_OBTIAZ_D:
      //label_debug_info->SetText((LPSTR) "Obtianos D");
      M = 8; N = 5;
      D = 10;
      volba = true;
      break;

    case IDC_DUIV_ZVUK_ZAP:
      //label_debug_info->SetText((LPSTR) "Zvuk zapn");
      ozvuc_zap = true;
      volba = true;
      break;
    case IDC_DUIV_ZVUK_VYP:
      //label_debug_info->SetText((LPSTR) "Zvuk vypn");
      ozvuc_zap = false;
      volba = true;
      break;
    }

    switch (ivalue)
    {
    case IDC_DUIV_OBTIAZ_A:
    case IDC_DUIV_OBTIAZ_B:
    case IDC_DUIV_OBTIAZ_C:
    case IDC_DUIV_OBTIAZ_D:
      Uprav_M_N(); //korekcia

      VYBER_KARTY_DVOJICE(M*N / 2);
      ZAMIESAJ_KARTY();
      ULOZ_KARTY();
      duir_FINAL.DELETE_ALL();  //vymazat nastenku

      lb_Gratul->visible = false;  //ak by bol nahodou zobrazeny
      break;
    }

  }

  if (volba )
  {
    //label_debug_info->GO_TO_Rel_Center(m_SX, m_SY);
    zvuk_4.SPUSTI();  //cvak
  }

  return l_b;
}

//----------------------------------------------------------------
// Volane po zmene rozmerov obrazovky
//----------------------------------------------------------------
void CMyApp::ChangedResolution(int maxx_old, int maxy_old, int maxx_new, int maxy_new)
{
  //postup cez dimenziu predkov (vratit funkcnost predkovi, lebo cez virtual bola obidena, prepisana)
  bf_CAppScreen::ChangedResolution(maxx_old, maxy_old, maxx_new, maxy_new);  //obsluzit class predka

  btn_menu->MoveToRel(m_SX - 70, 0);
  //label_debug_info->GO_TO_Rel_Center(m_SX, m_SY);

  int i;

  //re-natiahnutie ikon decentne
  bf_CIcon *ic;
  for (i = 0; i<REG_OBR.count; i++)
  {
    ic = (bf_CIcon *)REG_OBR.ARR[i];
    if (ic != NULL)
      ic->Das_Surface->RELOAD_SURFACE();
  }

  p_icon_back_side->Das_Surface->RELOAD_SURFACE();

  //Uprav_M_N(); //korekcia

  ULOZ_KARTY();

  //pri zmenseni rozlisenia posunut karty, ktore by mohli zmiznut alebo precuhovat von
  CKarta *k;
  if (maxx_old > maxx_new || maxy_old > maxy_new)
    for (i = 0; i<REG_KARTY.count; i++)
    {
      k = (CKarta *)REG_KARTY[i];
      if (k != NULL)
      {
        if (k->x + k->sir > maxx_new ) k->x -= (k->x + k->sir - maxx_new );
        if (k->y + k->vys > maxy_new ) k->y -= (k->y + k->vys - maxy_new );
      }
    }

}

//----------------------------------------------------------------
// Prekreslit celu scenu 
//----------------------------------------------------------------
void CMyApp::Redraw_Screen( LPDIRECTDRAWSURFACE p_lpDDS )
{
  //<--- vymazat
  //DDSURFACE_ZMAZ(p_lpDDS, 500);

  //<--- poloz karty   
  //------
  ZOBRAZ_KARTY(p_lpDDS);
  //------

  duir_FINAL.DRAW(p_lpDDS);

}

//----------------------------------------------------------------
// Vykreslit kurzor
//----------------------------------------------------------------
void CMyApp::DrawCursor( LPDIRECTDRAWSURFACE p_lpDDS )
{
  //<--- poloz kuzor
  kurzor.DRAW(p_lpDDS);
}


//======================================================================================

//----------------------------------------------------------------
// konverzia na int matematickym zaokruhlenim  (zo Sil)
// NOTE: bol totiz problem s volanim round() z <math.h>
//----------------------------------------------------------------
int bl_round(double hod_d)
{
  int hod_i = int(hod_d);

  if (hod_d > 0)
  {
    if ((hod_d - double(hod_i)) >= 0.5) hod_i++;
  }
  else if (hod_d < 0)
  {
    if ((double(hod_i) - hod_d) >= 0.5) hod_i--;
  }

  return hod_i;
}

//----------------------------------------------------------------
//----------------------------------------------------------------
HFONT My_Font_Create(int font_vys, int font_sir, LPCTSTR font_face)
{
  HFONT hfont = CreateFont(
    font_vys,                  // { height }
    font_sir,                  // { width }
    0,                         // { escapement }
    0,                         // { orientation }
    FW_BOLD,                   // { weight }
    0,                         // { italic }
    0,                         // { underline }
    0,                         // { strikeOut }
    EASTEUROPE_CHARSET,        // { char set }   ANSI_CHARSET, DEFAULT_CHARSET, EASTEUROPE_CHARSET
    OUT_DEFAULT_PRECIS,        // { OutputPrecision }
    CLIP_DEFAULT_PRECIS,       // { ClipPrecision }
    DEFAULT_QUALITY,           // { quality }
    VARIABLE_PITCH | FF_SWISS, // { PitchAndFamily }
    font_face                  //"Verdana" /*"Arial"*/  // { LPCTSTR lpszFace }
  );
  return hfont;
}


//----------------------------------------------------------------
// Ak treba nastavi v REG_TEXT lokalne fonty (aby text nepresahoval kartu)
//----------------------------------------------------------------
void font_SET2()
{
  HFONT font_NEW;
  HFONT font_OLD;

  //--- kontrola a pripadne nastavenie lokalnych fontov kartam
  int zist_sir, zist_vys;
  if (REG_TEXT.count <= 0) return;
  if (REG_TEXT.akt_alloc == 0 || REG_TEXT.ARR == NULL) return;  //niet co robit

  for (int i = 0; i<REG_TEXT.count; i++)
    if (REG_TEXT.ARR[i] != NULL)
    {
          SText *t = (SText *)REG_TEXT.ARR[i];
          zist_sir = 0; zist_vys = 0;
          //rozmery textu s globalnym fontom?
          bf_glob_ZISTI_ROZMER_TEXTU(t->text, glob_font_KARTY_HND, &zist_sir, &zist_vys);

          if (zist_sir < SIR_KARTA - 1)  //vojde sa text do karty?
            font_NEW = NULL;
          else  //nevosiel by sa? => urcime lokalny
          {
            double koef = double(SIR_KARTA - 1) / double(zist_sir);
            int nova_sir = bl_round(koef * double(glob_font_KARTY_SIR));
            //--------------
            font_NEW = My_Font_Create(glob_font_KARTY_VYS, nova_sir, glob_font_KARTY_FaceName );
            //-------------- 
          }

          font_OLD = t->font_local;
          t->font_local = font_NEW;
          if (font_OLD != NULL) DeleteObject(font_OLD);  //bol predtym nastaveny lokalny font? => deletnut ho ako objekt
    }
  bf_LOGT("---------", "REG_TEXT fonty nastavene");  //<<<<<<< DEBUG
}

//======================================================================================

//----------------------------------------------------------------
// Uvolnenie registrov
//----------------------------------------------------------------
void REG_UVOLNI()
{
  int poc;

  //uvolnit hlavne karty
  if (REG_KARTY.count > 0)
  {
    //rozpisany REG_KARTY.DetachAll(): na (CKarta *)
    if (REG_KARTY.akt_alloc == 0 || REG_KARTY.ARR == NULL)
    {
    } //niet co robit
    else
    {
      poc = REG_KARTY.count;
      REG_KARTY.count = 0;

      for (int i = 0; i<poc; i++)
        if (REG_KARTY.ARR[i] != NULL)
        {
          delete (CKarta *)REG_KARTY.ARR[i];  //uvolnit danu kartu
                                              //REG_KARTY.ARR[i] = NULL;
          REG_KARTY.SET(i, NULL);
        }
      //REG_KARTY.count = 0;
      bf_LOGT("---------", "REG_KARTY uvolneny");  //<<<<<<< DEBUG
    }
  }

  //uvolnit vazobne struktury ak su naplnene 

  if (REG_TEXT.count > 0) //REG_TEXT.DetachAll();
  {
    //rozpisany REG_OBR.DetachAll();  na (bf_CIcon *)
    if (REG_TEXT.akt_alloc == 0 || REG_TEXT.ARR == NULL)
    {
    } //niet co robit
    else
    {
      poc = REG_TEXT.count;
      REG_TEXT.count = 0;

      for (int i = 0; i<poc; i++)
        if (REG_TEXT.ARR[i] != NULL)
        { //uvolnit dany text s fontom
          SText *t = (SText *)REG_TEXT.ARR[i];
          DeleteObject(t->font_local);
          delete[] t->text;
          delete t;
          //REG_TEXT.ARR[i] = NULL;
          REG_TEXT.SET(i, NULL);
        }
      //REG_TEXT.count = 0;
      bf_LOGT("---------", "REG_TEXT uvolneny");  //<<<<<<< DEBUG
    }
  }

  if (REG_OBR.count  > 0)
  {
    //rozpisany REG_OBR.DetachAll();  na (bf_CIcon *)
    if (REG_OBR.akt_alloc == 0 || REG_OBR.ARR == NULL)
    {
    } //niet co robit
    else
    {
      poc = REG_OBR.count;
      REG_OBR.count = 0;

      for (int i = 0; i<poc; i++)
        if (REG_OBR.ARR[i] != NULL)
        {
          delete (bf_CIcon *)REG_OBR.ARR[i];  //uvolnit dany obraz
                                              //REG_OBR.ARR[i] = NULL;
          REG_OBR.SET(i, NULL);
        }
      //REG_OBR.count = 0;
      bf_LOGT("---------", "REG_OBR uvolneny");  //<<<<<<< DEBUG
    }
  }

  if (REG_ZVUK.count > 0)
  {
    //rozpisany REG_ZVUK.DetachAll(): na (bf_CDSO_Zvuk *)
    if (REG_ZVUK.akt_alloc == 0 || REG_ZVUK.ARR == NULL)
    {
    } //niet co robit
    else
    {
      poc = REG_ZVUK.count;
      REG_ZVUK.count = 0;

      for (int i = 0; i<poc; i++)
        if (REG_ZVUK.ARR[i] != NULL)
        {
          delete (bf_CDSO_Zvuk *)REG_ZVUK.ARR[i];  //uvolnit dany zvuk
                                                   //REG_ZVUK.ARR[i] = NULL;
          REG_ZVUK.SET(i, NULL);
        }
      //REG_ZVUK.count = 0;
      bf_LOGT("---------", "REG_ZVUK uvolneny");  //<<<<<<< DEBUG
    }
  }

}

//----------------------------------------------------------------
// Nacitanie dat pre karty (obraz, text, zvuk) podla obsahu adresara (bmp)
//----------------------------------------------------------------
void NACITAJ(char *folderpath /*, bool default_transpar =true*/)
{
  //TCHAR cesta_subor_bmp[500]; cesta_subor_bmp[0] = '\0'; //cesta s priponou .bmp (vzor,original)
  TCHAR cesta_subor_thm[500]; cesta_subor_thm[0] = '\0'; //cesta s priponou .bmp (vzor,original)
  TCHAR solo_nazov[100]; solo_nazov[0] = '\0';   //vyrezany nazov suboru
  TCHAR cesta_subor_wav[500]; cesta_subor_wav[0] = '\0'; //cesta s priponou .wav (prislusny zvuk)

  int xx = 10;
  int yy = 10;

//----------
  REG_UVOLNI();  //uvolnit datove struktury
//----------

  //vymazat nastenku
  duir_FINAL.DELETE_ALL();

  //pAPP->lb_Gratul->visible = false;

  //zrobit .thm k vsetkym .bmp
  //----------------------   
  bf_BMP_Vytvor__bmp2thm(folderpath, SIR_KARTA, VYS_KARTA, 1);
  //----------------------

  //natiahnut vsetky pritomne .thm subory s plnou cestou do kolekcie
  bf_CARRE  arre_THM_subory;
  unsigned subadr = 0;  //subory
  bool scestou = true;
  //-------------------
  if (bf_FSI_Zisti_SubAdr(folderpath, (char*) "*.thm", subadr, scestou, &arre_THM_subory) != 0)
    //-------------------
  {
    bf_LOGT("Doslo k chybe pri nacitani THM suborov", "X");
    assert(0);
  }

  //nechceme transparentnost v konstruktore ikony so suborom
  bf_Set_CIcon_default_transparency( 0 );
  
  //prechod cez detekovane .thm (.bmp) subory
  for (int i = 0; i<arre_THM_subory.count; i++)
  {
    //i-ta polozka (uplna cesta k bmp suboru)
    //char *ch = (char*) arre_THM_subory[ i ]; 
    TCHAR *ch = (TCHAR*)arre_THM_subory[i];   //TODO?!

    strcpy(cesta_subor_thm, ch);  //pracovna kopia uplnej cesty thm
    bf_FSI_Vystrihni_meno(cesta_subor_thm, solo_nazov); //vyrezat meno
    SText *p_txt = new SText();
    p_txt->text = _strdup(solo_nazov);
    p_txt->font_local = NULL;  //default bez lokalneho fontu
    REG_TEXT.ADD(p_txt);

    bf_CIcon *p_icon = new bf_CIcon(cesta_subor_thm);
    //p_icon->Das_Surface->TC=0;  //bez transp.
    REG_OBR.ADD(p_icon);

    //bf_LOGT1( "NACITAJ - cesta_subor_thm", cesta_subor_thm, i ); //<<<<<< DEBUG

    //------- externe WAWs (len vo filesysteme)
    bf_FSI_Zmen_priponu(ch, (char*) "wav", cesta_subor_wav);
    //existuje wav?
    if (bf_FSI_Existuje_sub(cesta_subor_wav))
    {
      bf_CDSO_Zvuk *p_zvuk = new bf_CDSO_Zvuk();
      p_zvuk->NAHRAJ(cesta_subor_wav);   //nahrat z filesystemu
      bf_LOGT("wav sub init", cesta_subor_wav);  //<<<<<<< DEBUG
      REG_ZVUK.ADD(p_zvuk);
    }
    else
    {
      REG_ZVUK.ADD(NULL);
      bf_LOGT("wav sub init", "NULL");  //<<<<<<< DEBUG
    }

    //-- 2x nova krabica karty
    // PridajKartu( xx, yy, i ); xx+=20; yy+=10;
    // PridajKartu( xx, yy, i ); xx+=20; yy+=10; 
  }

  //if (bf_MAXX < MAXX_D_Mantinel ) M = 5;  //stlpcov
  //else M = 6;    
  //N = 4;    //riadkov

  VYBER_KARTY_DVOJICE(M*N / 2);   //12
}

//----------------------------------------------------------------
//----------------------------------------------------------------
void PridajKartu(int xx, int yy, int iindex)
{
  CKarta *pk;
  pk = new CKarta();
  pk->x = xx;
  pk->y = yy;
  pk->sir = SIR_KARTA - 3;  // ehm, o 3 mensie
  pk->vys = VYS_KARTA2 - 3;  //VYS_KARTA-3;
  pk->pruh_h = 0;   //bez pruhu
  pk->pruh_senzitivnost = false; //uchopitelny celou obalkou!
  pk->index = iindex;
  pk->otvorena = false;  //true; DEBUG
  pk->draggable = false;  //TODO: spravit nastavitelnym cez setup dialog
  REG_KARTY.ADD(pk);
}

//----------------------------------------------------------------
//----------------------------------------------------------------
void Uprav_M_N()
{
  if (bf_Get_MAXX() < MAXX_D_Mantinel)  //korekcia
  {
    if (M > 5) M = 5;  //stlpcov
    if (N > 4) N = 4;  //riadkov
  }
}

//----------------------------------------------------------------
// Z nacitanych dat naplni strukturu kariet (zadany pocet a nahodne ak menej nez je v sade)
//----------------------------------------------------------------
void VYBER_KARTY_DVOJICE(int ppocet_dvojic)
{
  int i;
  int xx = 10;
  int yy = 10;
  int pocet_dvojic = ppocet_dvojic;

  //predmazat strukturu kariet ak tam daco je
  if (REG_KARTY.count > 0)
  {
    for (i = 0; i <= REG_KARTY.count - 1; i++)
    {
      CKarta *pk = (CKarta *)REG_KARTY[i];
      delete pk;
      REG_KARTY.Blenduj(i);  //t.j.: SET(i, NULL);
    }
    REG_KARTY.Zhod_count();
  }

  //ak chceme parametrom viac nez je obrazkov k dispozicii
  if (pocet_dvojic > REG_OBR.count)
    pocet_dvojic = REG_OBR.count;

  //je to kvazi 1:1
  if (pocet_dvojic == REG_OBR.count ||
    pocet_dvojic == REG_OBR.count - 1)
  {
    for (i = 0; i <= pocet_dvojic - 1; i++)  //vyber zaradom
    {
      PridajKartu(xx, yy, i); xx += 20; yy += 10;
      PridajKartu(xx, yy, i); xx += 20; yy += 10;
    }
  }
  else  //pocet_dvojic < REG_OBR.count => vyberame nahodnu podmnozinu
  {
    int index;
    double koef;
    bool vybraty[50 + 1];  //viac dvojic fakt neocakavame
    for (i = 0; i <= 50; i++) vybraty[i] = false;

    srand((unsigned)time(NULL));

    //bf_LOG1( "=====", 0 );  //<<<<<< DEBUG
    for (i = 0; i <= pocet_dvojic - 1; i++)
    {
      //vymysliet index obrazu
      koef = double(rand()) / double(RAND_MAX);
      index = int((REG_OBR.count - 1) * koef);

      //bf_LOG1( "random index", index );  //<<<<<< DEBUG

      if (index < 0) index = 0; //poistka, ale nemalo by nastat 
      if (index > REG_OBR.count - 1) index = REG_OBR.count - 1; //poistka, ale nemalo by nastat 

      while (vybraty[index])  //zly napad => zober najblizsi nevybrany
      {
        index++;
        if (index > REG_OBR.count - 1) index = 0; //zacyklit index
      }

      PridajKartu(xx, yy, index); xx += 20; yy += 10;
      PridajKartu(xx, yy, index); xx += 20; yy += 10;

      vybraty[index] = true;
    }
  }
}

//----------------------------------------------------------------
// Ulozenie kariet po obrazovke
//----------------------------------------------------------------
void ULOZ_KARTY()
{
  //presun hore ako globalky
  //int M = 6;    //stlpcov
  //int N = 4;    //riadkov
  //int O = 200;  //odsadenie pre DUIR
  //int D = 40;   //medzery

  //pevna vyhybka pre male rozlisenia - tam vzdy mala distancia kariet
  if (bf_Get_MAXX() < MAXX_D_Mantinel) D = 10;

  int krokx = SIR_KARTA + D;
  int kroky = VYS_KARTA2 + D;
  int startx = (bf_Get_MAXX() - O) / 2 - M * krokx / 2 + O;
  int starty = bf_Get_SY() - N * kroky / 2 + D / 2;

  int pocet = 1;
  int prstx, prsty;
  CKarta *pk;

  prsty = starty;
  for (int j = 1; j <= N && pocet <= REG_KARTY.count; j++)
  {
    prstx = startx;
    for (int i = 1; i <= M && pocet <= REG_KARTY.count; i++)
    {
      pk = (CKarta *)REG_KARTY[pocet - 1];
      pk->x = prstx;
      pk->y = prsty;
      pocet++;
      prstx += krokx;
    }
    prsty += kroky;
  }
}

//----------------------------------------------------------------
// Zamiesanie kariet
//----------------------------------------------------------------
void ZAMIESAJ_KARTY()
{
  // Seed the random-number generator with the current time so that  
  // the numbers will be different every time we run.  
  srand((unsigned)time(NULL));

  double koef;
  CKarta *pk1, *pk2;
  int i, pom, poc;

  //zratat viditelne karty na ploche - aspon 4 ?
  poc = 0;
  for (i = 0; i<REG_KARTY.count; i++)
  {
    if (((CKarta *)REG_KARTY[i])->visible) poc++;
    if (poc > 4) break;
  }
  if (poc < 4) return; //pod 4 karty sa nemiesa - dovi, dopo

                       //<--- cez vsetky viditelne karty
  for (i = 0; i<REG_KARTY.count; i++)
  {
    pk1 = (CKarta *)REG_KARTY[i];
    if (!pk1->visible) continue;  //preskoc neviditelne

                                    //vymysliet druhu kartu
    koef = double(rand()) / double(RAND_MAX);
    int i2 = int((REG_KARTY.count - 1) * koef);
    if (i2 < 0) i2 = 0; //poistka, ale nemalo by nastat 
    if (i2 > REG_KARTY.count - 1) i2 = REG_KARTY.count - 1; //poistka, ale nemalo by nastat 
    pk2 = (CKarta *)REG_KARTY[i2];

    if (!pk2->visible)  //zly napad, potom zober najblizsiu viditelnu 
      while (!pk2->visible)
      {
        i2++;
        if (i2 > REG_KARTY.count - 1) i2 = 0; //zacyklit index
        pk2 = (CKarta *)REG_KARTY[i2];
      }

    //vymenit indexy
    pom = pk1->index;
    pk1->index = pk2->index;
    pk2->index = pom;
  } //for i

}

//----------------------------------------------------------------
// Zobrazenie
//----------------------------------------------------------------
void ZOBRAZ_KARTY(LPDIRECTDRAWSURFACE d_SRF)
{
  CKarta *pde;
  RECT   R;
  HDC    hdc;
  int i;

  //<--- cez vsetky karty
  for (i = 0; i<REG_KARTY.count; i++)
  {
    CKarta *pk = (CKarta *)REG_KARTY[i];

    //zobrazit kartu ako taku 
    pk->DRAW(d_SRF);

    //obrazok a text na karte
    if (pk->visible)
    {
      if (pk->otvorena)
      {
        bf_CIcon *p_icon = (bf_CIcon *)REG_OBR[pk->index];
        p_icon->DRAW(d_SRF, pk->x, pk->y);

        //aj text pod kartou
        //i-ta polozka
        SText *p_txt = (SText*)REG_TEXT[pk->index];
        char  *ch = (char*)p_txt->text;

        if (d_SRF->GetDC(&hdc) == DD_OK)
        {
          R.left = pk->x;
          R.top = pk->y + VYS_KARTA;
          R.right = pk->x + pk->sir;
          R.bottom = pk->y + pk->vys;  //VYS_KARTA2; //pk->vys + 45;

          UINT zarovnaj_format = DT_CENTER + (DT_VCENTER + DT_SINGLELINE);

          if (p_txt->font_local == NULL)
            bf_glob_Text_draw_font(hdc, &R, zarovnaj_format, RGB(0, 0, 0), glob_font_KARTY_HND, ch);  //jednotnym globalnmym fontom
          else
            bf_glob_Text_draw_font(hdc, &R, zarovnaj_format, RGB(80, 0, 0), p_txt->font_local, ch);  //lokalnym fontom karty

          d_SRF->ReleaseDC(hdc);
        }
      }
      else
      {
        p_icon_back_side->DRAW(d_SRF, pk->x, pk->y);
      }
    } //if
  } //for i 

    //<--- zeleny ramcek okolo dotknuteho
  if (i_dotknuty >= 0)
  {
    pde = (CKarta *)REG_KARTY[i_dotknuty];

    R.left = pde->x;
    R.top = pde->y;
    R.right = pde->x + pde->sir;
    R.bottom = pde->y + pde->vys;

    if (d_SRF->GetDC(&hdc) == DD_OK)
    {
      SelectObject(hdc, GetStockObject(NULL_BRUSH));
      SelectObject(hdc, pero_ramec_1);  //zelene
      Rectangle(hdc, R.left, R.top, R.right, R.bottom);
      d_SRF->ReleaseDC(hdc);
    }
  }

  //<--- cerveny ramcek okolo chyteneho
  if (i_chyteny >= 0)
  {
    pde = (CKarta *)REG_KARTY[i_chyteny];

    R.left = pde->x;
    R.top = pde->y;
    R.right = pde->x + pde->sir;
    R.bottom = pde->y + pde->vys;

    if (d_SRF->GetDC(&hdc) == DD_OK)
    {
      SelectObject(hdc, GetStockObject(NULL_BRUSH));
      SelectObject(hdc, pero_ramec_2);  //cervene
      Rectangle(hdc, R.left, R.top, R.right, R.bottom);
      d_SRF->ReleaseDC(hdc);
    }
  }
}

//==============================================================================

//----------------------------------------------------------------
// Vstupny bod pre Appku
//----------------------------------------------------------------
int PASCAL WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance,
  LPSTR lpCmdLine, int nCmdShow)
{
  CMyApp *pAPP = new CMyApp(hInstance, nCmdShow, (char*) "PEXESO.INI");
  pAPP->SetBackground(500, (char*)"", false );   //modra farba pozadia, ziaden obraz ako podklad, ziadne logo
  pAPP->SetAppInfo((char*)"Pexeso", (char*)"(verzia: 1.0)", (char*)"Branislav Lehotsk", &rezia, 20, 40);
  pAPP->SetSysCursor( false );
  pAPP->SetLang(bf_c_Lang_SK);
  pAPP->Execute();
  delete pAPP;
  return 0;
}
